//+------------------------------------------------------------------+
//|                                                   Stochastic.mq4 |
//|                                                              xxx |
//|                                                              xxx |
//+------------------------------------------------------------------+
#property copyright "xxx"
#property link      "xxx"

//---- input parameters
extern double    TakeProfit=200;
extern double    StopLoss=120;
extern double    Lots=0.1;
extern double    TrailingStop=50;
extern double    BreakEven=30;
extern double    BEProfitValue=10;

extern int MainPeriod = PERIOD_M30;
extern int EntryPeriod = PERIOD_M1;
extern int KPeriod = 8;
extern int DPeriod = 3;
extern int Slowing = 3;
extern int ADXPeriod = 14;
extern int ADXPrice = 0;

datetime last_direction = 0;
int current_post = 0;
int digit = 0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//---- 

   //variables
   double SEMc, SESc, SMMc, SMSc, SEMp, SESp, SMMp, SMSp;
   double ADX1c, ADX2c;
   double trend;
   int cnt, ticket, total;   
   digit  = MarketInfo(Symbol(),MODE_DIGITS);
   
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<100)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
     
   SEMc=iStochastic(NULL,EntryPeriod,8,3,3,MODE_SMA,0,MODE_MAIN,0);
   SESc=iStochastic(NULL,EntryPeriod,8,3,3,MODE_SMA,0,MODE_SIGNAL,0);
   SMMc=iStochastic(NULL,MainPeriod,8,3,3,MODE_SMA,0,MODE_MAIN,0);
   SMSc=iStochastic(NULL,MainPeriod,8,3,3,MODE_SMA,0,MODE_SIGNAL,0);
   
   SEMp=iStochastic(NULL,EntryPeriod,8,3,3,MODE_SMA,0,MODE_MAIN,1);
   SESp=iStochastic(NULL,EntryPeriod,8,3,3,MODE_SMA,0,MODE_SIGNAL,1);
   SMMp=iStochastic(NULL,MainPeriod,8,3,3,MODE_SMA,0,MODE_MAIN,1);
   SMSp=iStochastic(NULL,MainPeriod,8,3,3,MODE_SMA,0,MODE_SIGNAL,1);
   
   ADX1c=iADX(NULL,MainPeriod,ADXPeriod,ADXPrice,1,0);
   ADX2c=iADX(NULL,MainPeriod,ADXPeriod,ADXPrice,2,0);
   
   //Check for main trend
   if((ADX1c>ADX2c) && (SMMc>SMSc && SMMc<80 && SMMc>20)) {
      trend = 0; //Uptrend
      }
   if((ADX1c<ADX2c) && (SMMc<SMSc && SMMc<80 && SMMc>20)) {
      trend = 1; //Downtrend
      }
      
   total  = OrdersTotal(); 
   if(total < 1) 
     {
     // No open positions
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
        //Check for Buy position
       if(last_direction != Time[0] ){
       last_direction = Time[0];
         if((trend==0) && (SEMc>SESc) && (SEMp<20 && SEMc>20))
         {
            ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"Stochastic",12345,0,Green);
            if(ticket>0)
              {
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
              }
            else Print("Error opening BUY order : ",GetLastError()); 
            return(0);
         }
          return(0);
        }
         //Check for Sell position
       if(last_direction != Time[0] ){
       last_direction = Time[0];
         if((trend==1) && (SEMc<SESc) && (SEMp>80 && SEMc<80))
         {
            ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"Stochastic",12345,0,Red);
            if(ticket>0)
              {
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
              }
            else Print("Error opening SELL order : ",GetLastError()); 
            return(0);
         }
          return(0);
        }
      return(0);
     }
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      OrderPrint();
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
           if((trend==1) || (SEMp>=80 && SEMc<=80))
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            //check for BreakEven
            if(BreakEven>0)
               {
               if (Bid-OrderOpenPrice()>Point*BreakEven) 
               {
               double BuyStop = OrderOpenPrice()+Point*BEProfitValue;
               OrderModify(OrderTicket(),OrderOpenPrice(),
                           NormalizeDouble(BuyStop, digit),
                           OrderTakeProfit(),0,LightGreen);
			      return(0);
			      }
			      return(0);
			      }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // should it be closed?
            if((trend==0) || (SEMp<=20 && SEMc>=20))
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            //check for BreakEven
            if(BreakEven>0)
               {
               if (OrderOpenPrice()-Ask>Point*BreakEven) 
               {
               double SellStop = OrderOpenPrice()-Point*BEProfitValue;
               OrderModify(OrderTicket(),OrderOpenPrice(),
   		                  NormalizeDouble(SellStop, digit),
   		                  OrderTakeProfit(),0,Yellow);	    
               return(0);
               }    
			      return(0);
			      }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }

   return(0);
  }
//+------------------------------------------------------------------+